package com.ruoyi.system.mapper;

import java.util.List;
import com.ruoyi.system.domain.SysSource;
import com.ruoyi.system.domain.dto.*;
import org.apache.ibatis.annotations.Param;

/**
 * 资源位Mapper接口
 * 
 * @author ruoyi
 * @date 2024-11-08
 */
public interface SysSourceMapper 
{
    /**
     * 查询资源位
     * 
     * @param sourceId 资源位主键
     * @return 资源位
     */
    public SysSource selectSysSourceBySourceId(Long sourceId);

    /**
     * 查询资源位列表
     * 
     * @param sysSource 资源位
     * @return 资源位集合
     */
    public List<SysSource> selectSysSourceList(SysSource sysSource);

    /**
     * 新增资源位
     * 
     * @param sysSource 资源位
     * @return 结果
     */
    public int insertSysSource(SysSource sysSource);

    /**
     * 修改资源位
     * 
     * @param sysSource 资源位
     * @return 结果
     */
    public int updateSysSource(SysSource sysSource);

    /*
    * 更新默认背景
    * */
    public int updateDefaultSourceWorkAddress(@Param("city") String city,@Param("scenic") String scenic,@Param("part") String part,@Param("sourceStatus") String sourceStatus, @Param("workAddress")String workAddress);

    public int updateDefaultSourcePrice(@Param("city") String city,@Param("scenic") String scenic,@Param("part") String part, @Param("price") String price);

    /**
     * 删除资源位
     * 
     * @param sourceId 资源位主键
     * @return 结果
     */
    public int deleteSysSourceBySourceId(Long sourceId);

    /**
     * 批量删除资源位
     * 
     * @param sourceIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSysSourceBySourceIds(Long[] sourceIds);

    public List<SourceListDto> getSysSourceList(SysSource sysSource);

    public List<HotSourceDto> getHotSource();

    public int updateSysSourceByCP(SysSource sysSource);

    /*
     * 查看我的发布资源位详情
     * */
    public List<UserPublishWorkSourceListDto> getUserPublishWorkSourceList(Long workId);

    /*
     * AR 获取资源位信息列表, 包括作品标题和介绍
     * */
    public List<ShowSysSourceARListDto> getSysSourceARList(SysSource sysSource);

    /**
     * 按xy坐标返回AR资源位图片
     * */
    public List<ShowSysSourceARListDto> getARSource(@Param("city") String city,  @Param("scenic") String scenic, @Param("coordinates") List<Coordinate> coordinates);
}
